/***{{{*******************************************************************
 * This file is part of libco - object library for C                     *
 * Copyright (c) 2003                                                    *
 *     Peter Rockai (yenar) <yenar@host.sk>                              *
 *                                                                       *
 * This library is free software; you can redistribute it and/or         *
 * modify it under the terms of the GNU Lesser General Public            *
 * License as published by the Free Software Foundation; either          *
 * version 2 of the License, or (at your option) any later version.      *
 *                                                                       *
 * This library is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 * Lesser General Public License for more details.                       *
 *                                                                       *
 * You should have received a copy of the GNU Lesser General Public      *
 * License along with this library; if not, write to the Free Software   *
 * Foundation, Inc., 59 Temple Place, Suite 330,                         *
 * Boston, MA 02111-1307  USA                                            *
 *******************************************************************}}}***/
/* {{{ file description */
/** @file co_object.h
 *  @brief Object definition and function prototypes. */
/* }}} */

#ifndef __CO_PYTHON_H__
#define __CO_PYTHON_H__

#include <python2.2/Python.h>

#include "co_type.h"
#include "co_exception.h"
#include "co_string.h"
#include "co_debug.h"

struct co_o_python {
	PyObject_HEAD;
	co co_object;
};
CO_TYPEDEF (co_o_python);

static void co_o_python_del (PyObject *self)
{
	co_o_python o = (co_o_python) self;
	CO_DEBUG (2, "python wishes to destroy %p", o -> co_object);
	//co_del (o -> co_object);
	PyObject_Del (self);
}

#endif /* __CO_PYTHON_H__ */
